;; 
;;
PRO BODY_MOTION_FOURIER_FILTER__DEFINE

    ; define the class structure 
    struct = { BODY_MOTION_FOURIER_FILTER, INHERITS signal_filter }

END


;; Creates new Body Motion Filter.
;;
FUNCTION BODY_MOTION_FOURIER_FILTER::INIT, SAMPLING_TIME=SAMPLING_TIME, MULTIPLEX_DIMENSION=MULTIPLEX_DIMENSION

    return, self->signal_filter::init(sampling_time=sampling_time, multiplex_dimension=multiplex_dimension)

END


;; 
;;
PRO BODY_MOTION_FOURIER_FILTER::CLEANUP

    self->signal_filter::cleanup

END

;;
;;
FUNCTION BODY_MOTION_FOURIER_FILTER::APPLY, DATA

    nyquist = self->get_nyquist_frequency()
    frequency_data = fft(reform(data), /double)
    n = n_elements(frequency_data)
    k = fix(0.05/nyquist * n)
    frequency_data[k:n-k-1] = 0.0
    return, smooth(fft(frequency_data, /inverse, /double), 500)

END
