;; 
;;
PRO RESPIRATORY_MOTION_DIGITAL_FILTER__DEFINE

    ; define the class structure 
    struct = { RESPIRATORY_MOTION_DIGITAL_FILTER, INHERITS signal_filter }

END


;; Creates new Respiratory Motion Filter.
;;
FUNCTION RESPIRATORY_MOTION_DIGITAL_FILTER::INIT, SAMPLING_TIME=SAMPLING_TIME, MULTIPLEX_DIMENSION=MULTIPLEX_DIMENSION

    return, self->signal_filter::init(sampling_time=sampling_time, multiplex_dimension=multiplex_dimension)

END


;; 
;;
PRO RESPIRATORY_MOTION_DIGITAL_FILTER::CLEANUP

    self->signal_filter::cleanup

END


;; TODO implement!
;;
FUNCTION RESPIRATORY_MOTION_DIGITAL_FILTER::APPLY, DATA
    return, data
END


;; Tries to filter a respiration signal so that only respiration related movements are left, while other 
;; movements and noise are discarded.
;; This is done by band pass filtering, for certain hard-coded frequencies. The actual implementation 
;; convolutes the data with a digital filter.
;; @param SIGNAL_DATA (IN) An array containing the samples of a respiration signal.
;; @param NYQUIST_FREQUENCY (IN) The nyquist frequency of the SIGNAL_DATA.
;; @return The filtered respiration signal.
;;
FUNCTION RESPIRATORY_MOTION_DIGITAL_FILTER::APPLY, DATA

    nyquist = self->get_nyquist_frequency()
    return, convol(reform(data), digital_filter(0.15/nyquist, 0.6/nyquist, 50, 200))

END
